Installation
============

See [INSTALL.md](INSTALL.md) file.


Configuration
=============

See [doc/documentation.txt](doc/documentation.txt) or [http://wiki2.dovecot.org/](http://wiki2.dovecot.org/)


RFCs conformed
==============


email
-----

- [RFC822 - Standard for ARPA Internet Text Messages](http://www.rfc-base.org/rfc-822.html)
- [RFC2822 - Internet Message Format (updated RFC822)](http://www.rfc-base.org/rfc-2822.html)
- [RFC2045 - Multipurpose Internet Mail Extensions (MIME) (part 1)](http://www.rfc-base.org/rfc-2045.html)
- [RFC2046 - Multipurpose Internet Mail Extensions (MIME) (part 2)](http://www.rfc-base.org/rfc-2046.html)
- [RFC2047 - Multipurpose Internet Mail Extensions (MIME) (part 3)](http://www.rfc-base.org/rfc-2047.html)
- [RFC2048 - Multipurpose Internet Mail Extensions (MIME) (part 4)](http://www.rfc-base.org/rfc-2048.html)
- [RFC2049 - Multipurpose Internet Mail Extensions (MIME) (part 5)](http://www.rfc-base.org/rfc-2049.html)

Auth
----         

- [RFC2245 - Anonymous SASL Mechanism.](http://www.rfc-base.org/rfc-2245.html)
- [RFC2595 - Using TLS with IMAP, POP3 and ACAP](http://www.rfc-base.org/rfc-2595.html)
- [RFC2831 - Using Digest Authentication as a SASL Mechanism (DIGEST-MD5)](http://www.rfc-base.org/rfc-2831.html)
- [RFC5802 - Salted Challenge Response Authentication Mechanism (SCRAM)](http://www.rfc-base.org/rfc-5802.html)
- SASL and GSS-API Mechanisms 
- [RFC7628 - A Set of Simple Authentication and Security Layer (SASL) Mechanisms for OAuth](https://tools.ietf.org/html/rfc7628)
- [Google XOAUTH2 protocol](https://developers.google.com/gmail/xoauth2_protocol)

POP3
----           

- [RFC1939 - Post Office Protocol - Version 3](http://www.rfc-base.org/rfc-1939.html)
- [RFC2449 - POP3 Extension Mechanism](http://www.rfc-base.org/rfc-2449.html)
- [RFC2595 - Using TLS with IMAP, POP3 and ACAP](http://www.rfc-base.org/rfc-2595.html)
- [RFC3206 - The SYS and AUTH POP Response Codes](http://www.rfc-base.org/rfc-3206.html)
- [RFC5034 - The Post Office Protocol (POP3) - Simple Authentication and Security Layer (SASL) Authentication Mechanism](http://www.rfc-base.org/rfc-5034.html)

IMAP base
---------

- [RFC3501 - IMAP4rev1](http://www.rfc-base.org/rfc-3501.html)
- [RFC2180 - IMAP4 Multi-Accessed Mailbox Practice](http://www.rfc-base.org/rfc-2180.html)
- [RFC2595 - Using TLS with IMAP, POP3 and ACAP](http://www.rfc-base.org/rfc-2595.html)
- [RFC2683 - IMAP4 Implementation Recommendations](http://www.rfc-base.org/rfc-2683.html)

IMAP extensions
---------------

- [RFC2087 - IMAP4 QUOTA extension](http://www.rfc-base.org/rfc-2087.html)
- [RFC2088 - IMAP4 non-synchronizing literals (LITERAL+)](http://www.rfc-base.org/rfc-2088.html)
- [RFC2177 - IMAP4 IDLE command](http://www.rfc-base.org/rfc-2177.html)
- [RFC2221 - IMAP4 Login Referrals](http://www.rfc-base.org/rfc-2221.html)
- [RFC2342 - IMAP4 Namespace](http://www.rfc-base.org/rfc-2342.html)
- [RFC2971 - IMAP4 ID extension](http://www.rfc-base.org/rfc-2971.html)
- [RFC3348 - IMAP4 Child Mailbox Extension](http://www.rfc-base.org/rfc-3348.html)
- [RFC3502 - IMAP4 MULTIAPPEND Extension](http://www.rfc-base.org/rfc-3502.html)
- [RFC3516 - IMAP4 Binary Content Extension](http://www.rfc-base.org/rfc-3516.html)
- [RFC3691 - IMAP4 UNSELECT command](http://www.rfc-base.org/rfc-3691.html)
- [RFC4314 - IMAP4 Access Control List (ACL) Extension](http://www.rfc-base.org/rfc-4314.html)
- [RFC4315 - IMAP UIDPLUS extension](http://www.rfc-base.org/rfc-4315.html)
- [RFC4467 - IMAP URLAUTH Extension](http://www.rfc-base.org/rfc-4467.html)
- [RFC4469 - IMAP CATENATE Extension](http://www.rfc-base.org/rfc-4469.html)
- [RFC4551 - IMAP Extension for Conditional STORE Operation or Quick Flag Changes Resynchronization](http://www.rfc-base.org/rfc-4551.html)
- [RFC4731 - IMAP4 Extension to SEARCH Command for Controlling What Kind of Information Is Returned](http://www.rfc-base.org/rfc-4731.html)
- [RFC4959 - IMAP Extension for Simple Authentication and Security Layer (SASL) Initial Client Response](http://www.rfc-base.org/rfc-4959.html)
- [RFC4978 - The IMAP COMPRESS Extension](http://www.rfc-base.org/rfc-4978.html)
- [RFC5032 - WITHIN Search Extension to the IMAP Protocol](http://www.rfc-base.org/rfc-5032.html)
- [RFC5161 - The IMAP ENABLE Extension](http://www.rfc-base.org/rfc-5161.html)
- [RFC5162 - IMAP4 Extensions for Quick Mailbox Resynchronization](http://www.rfc-base.org/rfc-5162.html)
- [RFC5182 - IMAP Extension for Referencing the Last SEARCH Result](http://www.rfc-base.org/rfc-5182.html)
- [RFC5255 - IMAP Internationalization (I18NLEVEL=1 only)](http://www.rfc-base.org/rfc-5255.html)
- [RFC5256 - IMAP SORT and THREAD Extensions](http://www.rfc-base.org/rfc-5256.html)
- [RFC5258 - IMAP4 - LIST Command Extensions](http://www.rfc-base.org/rfc-5258.html)
- [RFC5267 - Contexts for IMAP4 (ESORT and CONTEXT=SEARCH only)](http://www.rfc-base.org/rfc-5267.html)
- [RFC5464 - The IMAP METADATA Extension](http://www.rfc-base.org/rfc-5464.html)
- [RFC5465 - The IMAP NOTIFY Extension](http://www.rfc-base.org/rfc-5465.html)
- [RFC5524 - Extended URLFETCH for Binary and Converted Parts](http://www.rfc-base.org/rfc-5524.html)
- [RFC5530 - IMAP Response Codes](http://www.rfc-base.org/rfc-5530.html)
- [RFC5819 - IMAP4 Extension for Returning STATUS Information in Extended LIST](http://www.rfc-base.org/rfc-5819.html)
- [RFC5957 - Display-Based Address Sorting for the IMAP4 SORT Extension](http://www.rfc-base.org/rfc-5957.html)
- [RFC6154 - IMAP LIST Extension for Special-Use Mailboxes (SPECIAL-USE only)](http://www.rfc-base.org/rfc-6154.html)
- [RFC6203 - IMAP4 Extension for Fuzzy Search](http://www.rfc-base.org/rfc-6203.html)
- [RFC6785 - Support for IMAP Events in Sieve (via Pigeonhole plugin)](http://www.rfc-base.org/rfc-6785.html)
- [RFC6851 - Internet Message Access Protocol (IMAP) - MOVE Extension](http://www.rfc-base.org/rfc-6851.html)
- [RFC7162 - IMAP Extensions: Quick Flag Changes Resynchronization (CONDSTORE) and Quick Mailbox Resynchronization (QRESYNC) (updated RFC4551 and RFC5162)](http://www.rfc-base.org/rfc-7162.html)
- [RFC7888 - IMAP4 Non-synchronizing Literals (updated RFC2088)](http://www.rfc-base.org/rfc-7888.html)

SMTP/LMTP base
--------------

- [RFC821 - Simple Mail Transfer Protocol](http://www.rfc-base.org/rfc-821.html)
- [RFC2821 - Simple Mail Transfer Protocol (updated RFC821)](http://www.rfc-base.org/rfc-2821.html)
- [RFC5321 - Simple Mail Transfer Protocol (updated RFC2821)](http://www.rfc-base.org/rfc-5321.html)
- [RFC2033 - Local Mail Transfer Protocol](http://www.rfc-base.org/rfc-2033.html)
- [RFC6409 - Message Submission for Mail](http://www.rfc-base.org/rfc-6409.html)

SMTP/LMTP extensions
--------------------

- [RFC1870 - SMTP Service Extension for Message Size Declaration](http://www.rfc-base.org/rfc-1870.html)
- [RFC2034 - SMTP Service Extension for Returning Enhanced Error Codes](http://www.rfc-base.org/rfc-2034.html)
- [RFC2920 - SMTP Service Extension for Command Pipelining](http://www.rfc-base.org/rfc-2920.html)
- [RFC3030 - SMTP Service Extensions for Transmission of Large and Binary MIME Messages](http://www.rfc-base.org/rfc-3030.html)
- [RFC3207 - SMTP Service Extension for Secure SMTP over Transport Layer Security](http://www.rfc-base.org/rfc-3207.html)
- [RFC4468 - Message Submission BURL Extension](http://www.rfc-base.org/rfc-4468.html)
- [RFC4954 - SMTP Service Extension for Authentication](http://www.rfc-base.org/rfc-4954.html)
- [RFC6152 - SMTP Service Extension for 8-bit MIME Transport](http://www.rfc-base.org/rfc-6152.html)

Contact info
============

Timo Sirainen tss@iki.fi, [http://www.dovecot.org/](http://www.dovecot.org/)

Please use the Dovecot mailing list dovecot@dovecot.org for questions about Dovecot. You can post to the list without subscribing, the mail then waits in a moderator queue for a while. See [http://dovecot.org/mailinglists.html](http://dovecot.org/mailinglists.html)
